let read_int () = 
  Scanf.bscanf Scanf.Scanning.stdib " %d " (fun x -> x)

let pyramid_sizes bound = 
  let rec lowsize i = if i<=0 then 0 else i*i + (lowsize (i-2)) in
  let rec highsize i = if i<=0 then 0 else i*i + (highsize (i-1)) in

  let rec make_list sizefctn t i accum = 
    let size = sizefctn i in
      if size > bound then accum else make_list sizefctn t (i+1) ((size,(i,t))::accum)
  in
  let plist = make_list lowsize 'L' 3 (make_list highsize 'H' 2 []) in
    List.sort compare plist

let rec read_sizes ms accum = 
  let s = read_int() in
    if s=0 then (ms, List.rev accum) else read_sizes (max ms s) (s::accum)

let (ms, input_list) = read_sizes 0 []
let pyramids = Array.of_list (pyramid_sizes ms)
let n = Array.length pyramids
let count = Array.make (ms+1) (n+1)
let uses = Array.make_matrix n (ms+1) false

let _ =
  count.(0) <- 0;
  for p=0 to n-1 do
    let x = fst pyramids.(p) in
      for s=ms downto x do
	if count.(s) >= 1+count.(s-x) then (
	  count.(s) <- 1+count.(s-x);
	  uses.(p).(s) <- true
	)
      done
  done

let print_solution s = 
  let rec plist p s = 
    if p >= 0 then 
      let (x,(i,t)) = pyramids.(p) in
	if uses.(p).(s) then (
	  Printf.printf "%d%c " i t;
	  plist (p-1) (s-x)
	) else 
	  plist (p-1) s
  in  
    if count.(s) < n+1 then plist (n-1) s else Printf.printf "impossible"

let _ =
  for case=1 to List.length input_list do
    Printf.printf "Case %d: " case;
    print_solution (List.nth input_list (case-1));
    Printf.printf "\n";
  done
