let cross (x1,y1) (x2,y2) = (x1*.y2) -. (y1*.x2)
let ( -- ) (x1,y1) (x2,y2) = (x1-.x2, y1-.y2)
let len (x,y) = sqrt(x*.x +. y*.y)
let dot (x1,y1) (x2,y2) = x1*.x2 +. y1*.y2
let mul c (x,y) = (c*.x, c*.y)

let dist p q r = (* the distance from point r to the line from point p to point q *)
  let a = q -- p in
  let b = r -- p in
  let an = mul (1.0 /. (len a)) a in
  let v = mul (dot an b) an in
    len (b -- v)

let big = 1000000.0  (* bigger than the biggest trash bag *)
let eps = 1e-10

let solve n poly =
  let rec is_boundary i j k = 
    if k=n then true else
      if (cross (poly.(i) -- poly.(j)) (poly.(k) -- poly.(j))) +. eps <= 0.0 then false else
	is_boundary i j (k+1) 
  in

  let width i j = 
    let rec loop k best = 
      if k=n then best 
      else if k=i || k=j then loop (k+1) best 
      else loop (k+1) (max best (dist poly.(i) poly.(j) poly.(k)))
    in
      loop 0 0.0
  in
  
  let mind = ref big in
    for i=0 to n-1 do
      for j=0 to n-1 do
	if i!=j then begin
	  if is_boundary i j 0 then mind := min !mind (width i j)
	end
      done
    done;
    !mind

let read_int () = 
  Scanf.bscanf Scanf.Scanning.stdib " %d " (fun x -> x)

let rec solve_rest case = 
  let n = read_int() in
    if n>0 then
      let rec read_poly i accum = 
	if i=n then accum else
	  let x = read_int() in
	  let y = read_int() in
	    read_poly (i+1) (((float_of_int x),(float_of_int y))::accum)
      in
      let poly = Array.of_list (read_poly 0 []) in
	Printf.printf "Case %d: %6.2f\n" case ((solve n poly) +. 0.005);
	solve_rest (case+1)
;;

solve_rest 1
